/// <reference types="@adonisjs/application/build/adonis-typings" />
/// <reference types="@adonisjs/logger/build/adonis-typings/logger" />
import { ApolloServerBase } from 'apollo-server-core';
import { ApplicationContract } from '@ioc:Adonis/Core/Application';
import { HttpContextContract } from '@ioc:Adonis/Core/HttpContext';
import { LoggerContract } from '@ioc:Adonis/Core/Logger';
import { ApolloConfig } from '@ioc:Zakodium/Apollo/Server';
export default class ApolloServer extends ApolloServerBase {
    private $app;
    private $path;
    private $enableUploads;
    private $uploadOptions?;
    constructor(application: ApplicationContract, config: ApolloConfig, logger: LoggerContract);
    private createGraphQLServerOptions;
    applyMiddleware(): void;
    getGraphqlHandler(): (ctx: HttpContextContract) => Promise<string | void>;
    getUploadsMiddleware(): (ctx: HttpContextContract, next: () => void) => Promise<void>;
}
